<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/calAsq2fe.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>calAsq2fe.c</h1><a href="calAsq2fe_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: calAsq2fe.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="util_8h.html#a8f05188956349e674ebab809a737d8f4">00029</a> <span class="keywordtype">int</span> <a class="code" href="calAsq2fe_8c.html#ad998956cea43bafdea933b9d7df03198">CalAsq2fe</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,PetscReal *vertxyz2,PetscReal *bbox,<span class="keywordtype">int</span> *pix,
<a name="l00030"></a>00030               <span class="keywordtype">int</span> slice_id,Mat *pAIpol)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <span class="keywordtype">int</span>         i,j,k,l;
<a name="l00033"></a>00033   Mat         AIpol;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordtype">int</span> rank,size;
<a name="l00039"></a>00039   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00040"></a>00040   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00043"></a>00043     <span class="stringliteral">&quot;Calculating interpolation matrix sq-&gt;fe for volume with pid %i\n&quot;</span>
<a name="l00044"></a>00044     <span class="stringliteral">&quot;in bbox (%g,%g,%g) (%g,%g,%g) with %i x %i x %i pixels\n&quot;</span>,
<a name="l00045"></a>00045     slice_id+1,
<a name="l00046"></a>00046     bbox[0],bbox[1],bbox[2],bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+0],bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+1],bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+2],
<a name="l00047"></a>00047     pix[0],pix[1],pix[2]
<a name="l00048"></a>00048   );
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keywordflow">if</span> (!rank) {
<a name="l00051"></a>00051     ierr = MatCreateMPIAIJ(
<a name="l00052"></a>00052       PETSC_COMM_WORLD,
<a name="l00053"></a>00053       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1],
<a name="l00054"></a>00054       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1],
<a name="l00055"></a>00055       <a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,
<a name="l00056"></a>00056       &amp;AIpol
<a name="l00057"></a>00057     );CHKERRQ(ierr);
<a name="l00058"></a>00058   }
<a name="l00059"></a>00059   <span class="keywordflow">else</span> {
<a name="l00060"></a>00060     ierr = MatCreateMPIAIJ(
<a name="l00061"></a>00061       PETSC_COMM_WORLD,
<a name="l00062"></a>00062       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,0,
<a name="l00063"></a>00063       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1],
<a name="l00064"></a>00064       <a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,
<a name="l00065"></a>00065       &amp;AIpol
<a name="l00066"></a>00066     );CHKERRQ(ierr);
<a name="l00067"></a>00067   }
<a name="l00068"></a>00068   ierr = MatSetFromOptions(AIpol);CHKERRQ(ierr);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordflow">for</span> (l=0;l&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;l++) {
<a name="l00071"></a>00071     PetscReal   *v, p[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     <span class="keywordflow">if</span> (slice_id&gt;=0 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[l] != slice_id) <span class="keywordflow">continue</span>;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075     <span class="comment">/* calculate which pixel the x2 and y2 coordinates of the</span>
<a name="l00076"></a>00076 <span class="comment">       vertex correspond to; z2 value neglected -</span>
<a name="l00077"></a>00077 <span class="comment">       thus all nodes are effectively projected into the x2-y2 plane!</span>
<a name="l00078"></a>00078 <span class="comment">    */</span>
<a name="l00079"></a>00079     v=vertxyz2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[l];
<a name="l00080"></a>00080     i=(int) floor(pix[0]*(v[0]-bbox[0])/(bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+0]-bbox[0]));
<a name="l00081"></a>00081     j=(int) floor(pix[1]*(v[1]-bbox[1])/(bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+1]-bbox[1]));
<a name="l00082"></a>00082 
<a name="l00083"></a>00083     PetscReal a,b;
<a name="l00084"></a>00084     a=b=-2;
<a name="l00085"></a>00085     <span class="keywordflow">if</span> (i&lt;0) {i=0;a=-1;}
<a name="l00086"></a>00086     <span class="keywordflow">if</span> (j&lt;0) {j=0;b=-1;}
<a name="l00087"></a>00087     <span class="keywordflow">if</span> (i&gt;=pix[0]) {i=pix[0]-1;a=+1;}
<a name="l00088"></a>00088     <span class="keywordflow">if</span> (j&gt;=pix[1]) {j=pix[1]-1;b=+1;}
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     <span class="comment">/* calculate xyz coordinates of pixel</span>
<a name="l00091"></a>00091 <span class="comment">       NB: keep integers (i,pix[0]) separated by float</span>
<a name="l00092"></a>00092 <span class="comment">       otherwise division of integers always gives 0!</span>
<a name="l00093"></a>00093 <span class="comment">    */</span>
<a name="l00094"></a>00094     p[0]=bbox[0]+i*(bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+0]-bbox[0])/pix[0];
<a name="l00095"></a>00095     p[1]=bbox[1]+j*(bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+1]-bbox[1])/pix[1];
<a name="l00096"></a>00096     p[2]=0;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     <span class="comment">/* calculate weight factors unless they were set above */</span>
<a name="l00099"></a>00099     <span class="keywordflow">if</span> (a&lt;-1.5) a=pix[0]*(v[0]-p[0])/(bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+0]-bbox[0])*2.0-1.0;
<a name="l00100"></a>00100     <span class="keywordflow">if</span> (b&lt;-1.5) b=pix[1]*(v[1]-p[1])/(bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+1]-bbox[1])*2.0-1.0;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     <span class="keywordflow">for</span> (k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00103"></a>00103       PetscReal   matele;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105       matele=(1-a)*(1-b)/4.0;
<a name="l00106"></a>00106       ierr = MatSetValue(AIpol,
<a name="l00107"></a>00107         ND*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[l]+k,
<a name="l00108"></a>00108         ND*((i+0)*pix[1]+(j+0))+k,
<a name="l00109"></a>00109       matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00110"></a>00110 
<a name="l00111"></a>00111       matele=(1-a)*(1+b)/4.0;
<a name="l00112"></a>00112       ierr = MatSetValue(AIpol,
<a name="l00113"></a>00113         ND*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[l]+k,
<a name="l00114"></a>00114         ND*((i+0)*pix[1]+(j+1))+k,
<a name="l00115"></a>00115       matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117       matele=(1+a)*(1-b)/4.0;
<a name="l00118"></a>00118       ierr = MatSetValue(AIpol,
<a name="l00119"></a>00119         ND*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[l]+k,
<a name="l00120"></a>00120         ND*((i+1)*pix[1]+(j+0))+k,
<a name="l00121"></a>00121       matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123       matele=(1+a)*(1+b)/4.0;
<a name="l00124"></a>00124       ierr = MatSetValue(AIpol,
<a name="l00125"></a>00125         ND*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[l]+k,
<a name="l00126"></a>00126         ND*((i+1)*pix[1]+(j+1))+k,
<a name="l00127"></a>00127       matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00128"></a>00128     }
<a name="l00129"></a>00129   }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   PetscInfo(0,<span class="stringliteral">&quot;AIpol matrix assembly complete\n&quot;</span>);
<a name="l00132"></a>00132   ierr = MatAssemblyBegin(AIpol,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00133"></a>00133   ierr = MatAssemblyEnd(AIpol,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="comment">/* TODO: we should not miss any nodes any more</span>
<a name="l00137"></a>00137 <span class="comment">     remove this section (down to the assert) if this holds true</span>
<a name="l00138"></a>00138 <span class="comment">  */</span>
<a name="l00139"></a>00139   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Checking for missing nodes\n&quot;</span>);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   Vec       test1,test2;
<a name="l00142"></a>00142   <span class="keywordtype">int</span>       cnt=0;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;test2);
<a name="l00145"></a>00145   ierr = VecCreate(PETSC_COMM_WORLD,&amp;test1);CHKERRQ(ierr);
<a name="l00146"></a>00146   <span class="keywordflow">if</span> (!rank) {
<a name="l00147"></a>00147     ierr = VecSetSizes(test1,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1],<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1]);CHKERRQ(ierr);
<a name="l00148"></a>00148   }
<a name="l00149"></a>00149   <span class="keywordflow">else</span>{
<a name="l00150"></a>00150     ierr = VecSetSizes(test1,0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*pix[0]*pix[1]);CHKERRQ(ierr);
<a name="l00151"></a>00151   }
<a name="l00152"></a>00152   ierr = VecSetFromOptions(test1);CHKERRQ(ierr);
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   ierr = VecSet(test1,1.0);CHKERRQ(ierr);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   ierr = MatMult(AIpol,test1,test2);CHKERRQ(ierr);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   PetscReal *atest2;
<a name="l00159"></a>00159   ierr = VecGetArray(test2,&amp;atest2);CHKERRQ(ierr);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="keywordflow">for</span> (l=0;l&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;l++) {
<a name="l00162"></a>00162     PetscReal   *v;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     <span class="keywordflow">if</span> (slice_id&gt;=0 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[l] != slice_id) <span class="keywordflow">continue</span>;
<a name="l00165"></a>00165     <span class="keywordflow">if</span> (atest2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*l]&gt;0.5) <span class="keywordflow">continue</span>;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167     <span class="comment">/* calculate which pixel the x2 and y2 coordinates of the</span>
<a name="l00168"></a>00168 <span class="comment">       vertex correspond to; z2 value neglected -</span>
<a name="l00169"></a>00169 <span class="comment">       thus all nodes are effectively projected into the x2-y2 plane!</span>
<a name="l00170"></a>00170 <span class="comment">    */</span>
<a name="l00171"></a>00171     v=vertxyz2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[l];
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     i=(int) floor(pix[0]*(v[0]-bbox[0])/(bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+0]-bbox[0]));
<a name="l00174"></a>00174     j=(int) floor(pix[1]*(v[1]-bbox[1])/(bbox[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+1]-bbox[1]));
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="comment">/*</span>
<a name="l00177"></a>00177 <span class="comment">    PetscPrintf(PETSC_COMM_WORLD,</span>
<a name="l00178"></a>00178 <span class="comment">      &quot;missed node %i (%g,%g,%g), would need pixel %i %i, matele %g\n&quot;,</span>
<a name="l00179"></a>00179 <span class="comment">      gdata-&gt;vertl2g[l],v[0],v[1],v[2],i,j,atest2[ND*l]</span>
<a name="l00180"></a>00180 <span class="comment">    );</span>
<a name="l00181"></a>00181 <span class="comment">*/</span>
<a name="l00182"></a>00182 
<a name="l00183"></a>00183     <span class="keywordflow">if</span> (i&lt;0) i=0;
<a name="l00184"></a>00184     <span class="keywordflow">if</span> (j&lt;0) j=0;
<a name="l00185"></a>00185     <span class="keywordflow">if</span> (i&gt;=pix[0]) i=pix[0]-1;
<a name="l00186"></a>00186     <span class="keywordflow">if</span> (j&gt;=pix[1]) j=pix[1]-1;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keywordflow">for</span> (k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00189"></a>00189       ierr = MatSetValue(AIpol,
<a name="l00190"></a>00190         ND*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[l]+k,
<a name="l00191"></a>00191         ND*((i+1)*pix[1]+(j+1))+k,
<a name="l00192"></a>00192       1.0,ADD_VALUES);CHKERRQ(ierr);
<a name="l00193"></a>00193     }
<a name="l00194"></a>00194     cnt++;
<a name="l00195"></a>00195   }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   ierr = VecRestoreArray(test2,&amp;atest2);CHKERRQ(ierr);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   PetscInfo(0,<span class="stringliteral">&quot;AIpol matrix assembly complete\n&quot;</span>);
<a name="l00200"></a>00200   ierr = MatAssemblyBegin(AIpol,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00201"></a>00201   ierr = MatAssemblyEnd(AIpol,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00202"></a>00202   ierr = <a class="code" href="printmatinfo_8c.html#a8c62a6053be02438e1bf2da1efa06f1f">PrintMatInfoAll</a>(AIpol);CHKERRQ(ierr);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   PetscSynchronizedPrintf(PETSC_COMM_WORLD,
<a name="l00205"></a>00205     <span class="stringliteral">&quot;&lt;%i&gt;Added %i nodes\n&quot;</span>,
<a name="l00206"></a>00206     rank,cnt
<a name="l00207"></a>00207   );
<a name="l00208"></a>00208   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   assert(cnt==0);
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">/* check interpolation matrix */</span>
<a name="l00214"></a>00214   PetscReal area;
<a name="l00215"></a>00215   ierr = <a class="code" href="area_8c.html#ae10b3dfec502fed986fa89fea83631f9">AreaCal</a>(AIpol,&amp;area);CHKERRQ(ierr);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   *pAIpol=AIpol;
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

